#!/bin/sh

KDIR=$(pwd)/linux

if [ -e mali.ko ]; then
  VERSION=`cat ${KDIR}/Makefile | grep -E '^VERSION.=' | cut -d "=" -f 2- | tr -d " \t\n\r"`
  PATCHLEVEL=`cat ${KDIR}/Makefile | grep PATCHLEVEL.= | cut -d "=" -f 2- | tr -d " \t\n\r"`
  SUBVERSION=`cat ${KDIR}/Makefile | grep SUBLEVEL.= | cut -d "=" -f 2- | tr -d " \t\n\r"`
  ARCH=arm64
  LOCALVERSION="+c2"

  #cp -p ump.ko /lib/modules/${VERSION}.${PATCHLEVEL}.${SUBVERSION}${LOCALVERSION}/kernel/
  cp -p mali.ko /lib/modules/${VERSION}.${PATCHLEVEL}.${SUBVERSION}${LOCALVERSION}/kernel/
  depmod ${VERSION}.${PATCHLEVEL}.${SUBVERSION}${LOCALVERSION}
fi

dpkg -i mali450-meson_*_arm64.deb

i=/usr/include/umplock

if [ -e ${i} -a ! -e ${i}.disabled ]; then
  mv ${i} ${i}.disabled
fi

l=/usr/lib/aarch64-linux-gnu

#libwayland-egl.so.1.0.0
for s in libEGL.so.1.0.0 libGLESv1_CM.so.1.1.0 libGLESv2.so.2.0.0 ; do
  a=`echo ${s} | cut -d . -f 1-2`
  b=`echo ${s} | cut -d . -f 1-3`
  c=`echo ${s} | cut -d . -f 1-4`
  d=none

  if [ -e ${l}/${s} ]; then
    if readlink ${l}/${s} > /dev/null ; then
      d=`readlink ${l}/${s}`
      d=`basename ${d}`
    fi
  fi
  echo $d $s

  if [ "X${d}" != "XlibMali.so" ]; then
    if [ -e ${l}/${s} -a ! -e ${l}/${s}.distrib ]; then
      dpkg-divert --local --rename --add ${l}/${s}
    fi

    ln -s ./libMali.so ${l}/${s}
    [ ! -e ${l}/${c} ] && ln -s ${s} ${l}/${c}
    [ ! -e ${l}/${b} ] && ln -s ${c} ${l}/${b}
    [ ! -e ${l}/${a} ] && ln -s ${b} ${l}/${a}
  fi
done

if [ -e ${l}/libMali.so -a ! -e ${l}/libMali.so.distrib ]; then
  dpkg-divert --local --rename --add ${l}/libMali.so
fi

cp -p /usr/lib/aarch64-linux-gnu/mali450-meson/libMali.so ${l}

echo OK
